/*
 Copyright 2016 Goldman Sachs.
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing,
 software distributed under the License is distributed on an
 "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 KIND, either express or implied.  See the License for the
 specific language governing permissions and limitations
 under the License.
 */

package com.gs.fw.common.mithra.aggregate.operation;



public class HavingEqFilter<T extends Comparable> implements HavingFilter<T>
{
    private static HavingEqFilter instance = new HavingEqFilter();

    private HavingEqFilter()
    {
    }

    public static HavingEqFilter getInstance()
    {
        return instance;
    }

    public boolean matches(T aggregationResultValue, T filterValue)
    {
        return aggregationResultValue.compareTo(filterValue) == 0;
    }

    public String getFilterExpression()
    {
        return " =  ? ";
    }
}
